#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <dos.h>
#include <io.h>

typedef unsigned char   byte;
typedef unsigned short  word;
typedef unsigned long  dword;

// wb_[ (688 Bytes)
struct D88_HEADER {
	byte fd_name[17]; // fBXN̖O(ASCIIZ)
	byte res[9];  // U[u (00H)
	byte protect; // CgveNg (00H:Ȃ,10H:)
	byte fd_type; // fBXN̎   (00H:2D,10H:2DD,20H:2HD)
	unsigned long fd_size; // fBXÑTCY
};

// ZN^[ (16 Bytes)
struct D88_SECTOR {
	struct {
		byte c;
		byte h;
		byte r;
		byte n;
	} id;
	short count;  // ZN^[
	byte mfm_flg; // L^x     (00H:{x,40H:Px)
	byte del_flg; // DELETED DATA (00H:m[},10H:DELETED DATA)
	byte stat;    // Xe[^X   (00H:m[}Gh,̑G[[DISK BIOSԂXe[^X])
	byte res[5];  // U[u     (00H)
	short size;   // ZN^[̃TCY
};

void dump(short cnt,byte *buff)
{
	while(cnt--) printf("%02x,",*buff++);
	printf("\n");
}

void d88sct_disp(short num,struct D88_SECTOR *s)
{
	printf("%03d:%03d ",num+1,(s->id.r));
	printf("(C%02x H%02x R%02x N%02x) ",(s->id.c),(s->id.h),(s->id.r),(s->id.n));
	printf(":%04d ",(s->count));
	printf(":%04d ",(s->size));
	printf("MFM:%02x ",(s->mfm_flg));
	printf("DEL:%02x ",(s->del_flg));
	printf("STAT:%02x ",(s->stat));
	printf("\n");
}

short test_d88(byte *fname)
{
	static long trk_tbl[168];
	struct D88_HEADER d88hed;
	struct D88_SECTOR d88sct;
	short trk,sct,sct_cnt;
	short err;
	long adr;
	FILE *fp;

	fp=fopen(fname,"rb");
	if(fp==NULL) return 1;

	err=0;
	fread(&d88hed,1,sizeof(struct D88_HEADER),fp);
	printf("  :%s\n"  ,d88hed.fd_name);
	printf("ػް:"); dump(9,d88hed.res);
	printf("  :%02x\n",d88hed.protect);
	printf("  :%02x\n",d88hed.fd_type);
	printf("  :%ld\n" ,d88hed.fd_size);

	memset(trk_tbl,0,168*4);
	fread(trk_tbl,4,164,fp);

	for(trk=0; trk<164; trk++){
		if(ferror(fp)){ err=1; break; }
		if(!trk_tbl[trk]){
			printf("[ׯNo.%02d] \n",trk);
		} else {
			adr=trk_tbl[trk];
			fseek(fp,adr,SEEK_SET);
			fread(&d88sct,1,sizeof(struct D88_SECTOR),fp);
			sct_cnt=d88sct.count;
			printf("[ׯNo.%02d] %d \n",trk,sct_cnt);

			for(sct=0; sct<sct_cnt; sct++){
				fseek(fp,adr,SEEK_SET);
				adr+=(long)fread(&d88sct,1,sizeof(struct D88_SECTOR),fp);
				adr+=(long)d88sct.size;
				printf("   "); d88sct_disp(sct,&d88sct);
			}
			while(
				(trk< 163 && adr<trk_tbl[trk+1]) ||
				(trk==163 && adr<d88hed.fd_size)
			){
				fseek(fp,adr,SEEK_SET);
				adr+=(long)fread(&d88sct,1,sizeof(struct D88_SECTOR),fp);
				adr+=(long)d88sct.size;
				printf(" # "); d88sct_disp(sct,&d88sct);
			}
		}
	}

	fclose(fp);

	return err;
}

void main(int argc,byte *argv[],byte *envp[])
{
	test_d88(argv[1]);
}

