#include <stdio.h>
#include <string.h>
#include <io.h>
#include <i86.h>
#include <dos.h>
#include <fcntl.h>
#include "x1.h"
#include "x1_vram.h"
#include "x1_tape.h"
#include "x1_opm.h"
#include "msdos.h"
#include "text.h"
#include "debug.h"

/*
void _KC_DISP(word code)
{
	static byte tbl[]="0123456789ABCDEF";
	static byte str[64];

	str[2]=0; str[1]=tbl[code&15];
	code>>=4; str[0]=tbl[code&15];
	etext(40,20,2,0x26,str);
}
*/

//**********************************************************************

static byte HIT_TBL[0x100]={0};

static byte _KANA_=0;
static byte _CAPS_=0;
#define _CTRL_ (HIT_TBL[0x1d]|HIT_TBL[0x9d])
#define _SHFT_ (HIT_TBL[0x2a]|HIT_TBL[0x36])
#define _GRPH_ (HIT_TBL[0x38])

static byte KEY_INT=0;
static byte KEY_HIT=0;
static byte KEY_CHR=0;

/**********************************************************************
	^C}[
**********************************************************************/

static short TENT=0;
static short TCNT=0;
static long  TFRQ=1;
static long  TCLK=0;

/*
static long PCM_RATE=22050l;
static word PCM_SIZE=22050/60;
static byte PCM_BUFF[0x1000];
*/

short tcnt_get_at(void){ return TCNT; }
void tcnt_set_at(short cnt){ TCNT=cnt; }

void (interrupt far *org_08h_at)(void);

void interrupt far new_08h_at(void)
{
	TCLK+=TFRQ;
  if(TCLK>0xffff){
		TCLK&=0xffff;
		(*org_08h_at)();
	}

	TCNT++;
	outp(0x00,0x20);
	outp(0x20,0x20);
}

void timer_ini_at(long rate)
{
/*
	PCM_RATE=22050l;
	PCM_SIZE=(word)(PCM_RATE/rate);
*/

	TCNT=0;
	TCLK=0;

	// 1193180ĂłPb
	TFRQ=(1193180l/rate); // 1/rateb

	_disable();
	org_08h_at=_dos_getvect(0x08);
	_dos_setvect(0x08,new_08h_at);

	// outp(0x21,inp(0x21)|0x01);
	outp(0x43,0x36);
	outp(0x40,TFRQ&0xff);
	outp(0x40,TFRQ>>0x8);
	outp(0x21,inp(0x21)&0xfe);

	_enable();
}

void timer_end_at(void)
{
	_disable();
	// outp(0x21,inp(0x21)|0x01);
	outp(0x43,0x36);
	outp(0x40,0);
	outp(0x40,0);
	_dos_setvect(0x08,org_08h_at);
	_enable();
}

/**********************************************************************
	L[{[h荞
**********************************************************************/

void (interrupt _far *old_09h_at)();

static word sft_key(void)
{
	word sf;
	sf=0;
	if(_SHFT_) sf|=0x01; // SHIFT
	if(_CAPS_) sf|=0x02; // CAPS
	if(_KANA_) sf|=0x04; // KANA
	if(_GRPH_) sf|=0x08; // GRPH
	if(_CTRL_) sf|=0x10; // CTRL
	return sf;
}

void interrupt _far new_09h_at(void)
{
	static word ext=0;
	static word sw0=0;
	static word sw1=0;
	static word dat,key;

	dat=inp(0x60); /* get scancode */

	if(     dat==0xe0) ext=0x80;
	else if(dat!=0xe0){
		sw1=(dat&0x80)?0:1;
		key=(dat&0x7f)+ext; ext=0;
		sw0=HIT_TBL[key];
		HIT_TBL[key]=sw1;

		// DEBUGֳ
		SHIFT_KEY=_SHFT_;
#if BOSS==1
		if(key==0xcf) END_SW=99; // BOSS
#endif

		if(       key==0x29){ // /S
			if(sw0==0 && sw1==1) _KANA_^=1;
		} else if(key==0x3a){ // CapsLock
			if(sw0==0 && sw1==1) _CAPS_^=1;
		} else if(key==0x38){ // ALT(GRPH)
			KEY_INT=1; KEY_HIT=sw1; KEY_CHR=0;
		} else if(key==0x2a || key==0x36){ // SHIFT
			KEY_INT=1; KEY_HIT=sw1; KEY_CHR=0;
		} else if(key==0x1d || key==0x9d){ // CTRL
			KEY_INT=1; KEY_HIT=sw1; KEY_CHR=0;
		} else {
			KEY_INT=1; KEY_HIT=sw1; KEY_CHR=key;
		}
	}

	dat=inp(0x61);
	outp(0x61,dat|0x80);
	outp(0x61,dat);

	outp(0x20,0x20);
}

void kb_init_at(void)
{
	KEY_INT=0;
	KEY_HIT=0;
	KEY_CHR=0;

	memset(HIT_TBL,0,256);

	_disable();
	old_09h_at=_dos_getvect(0x09);
	_dos_setvect(0x09,new_09h_at);
	_enable();
}

void kb_reset_at(void)
{
	_disable();
	_dos_setvect(0x09,old_09h_at);
	_enable();
}

/**********************************************************************
	L[{[h
**********************************************************************/

// BASE
byte CHR_TBL0[]={
//  --  ESC   P   Q   R   S   T   U   V   W   X   O   |   O   BS  TAB 
  0x00,0x1b, '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '-', '^',0x08,0x09,
//  p   v   d   q   s   x   t   h   n   o      m  Ent Ctrl   `   r 
   'q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p', '@', '[',0x0d,0x00, 'a', 's',
//  c   e   f   g   i   j   k   G   F   S SftL   n   y   w   b   u 
   'd', 'f', 'g', 'h', 'j', 'k', 'l', ';', ':',0x00,0x00, ']', 'z', 'x', 'c', 'v',
//  a   m   l   C   D   ^ SftR  [*]  Alt  SPC  Cap  f.1  f.2  f.3  f.4  f.5 
   'b', 'n', 'm', ',', '.', '/',0x00,0x2a,0x00, ' ',0x00, 'q', 'r', 's', 't', 'u',
// f.6  f.7  f.8  f.9 f.10 Paus ScrL  [7]  [8]  [9]  [-]  [4]  [5]  [6]  [+]  [1] 
  0xec,0xeb,0xe2,0xe1,0xe8,0x13,0x00, '7', '8', '9', '-', '4', '5', '6', '+', '1',
// [2]  [3]  [0]  [.]  ???  ???  ??? f.11 f.12
   '2', '3', '0', '.',0x00,0x00,0x00,0x00,'\\'
};

// SHIFT
byte CHR_TBL1[]={
// --   ESC   P   Q   R   S   T   U   V   W   X   O   |   O   BS  TAB 
  0x00,0x1b, '!',0x22, '#', '$',0x25, '&',0x27, '(', ')', '0', '=',0x60,0x12,0x09,
//  p   v   d   q   s   x   t   h   n   o      m  Ent Ctrl   `   r 
   'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P',0x7e, '}',0x0d,0x00, 'A', 'S',
//  c   e   f   g   i   j   k   G   F   S SftL   n   y   w   b   u 
   'D', 'F', 'G', 'H', 'J', 'K', 'L', '+',0x2a,0x00,0x00, '}', 'Z', 'X', 'C', 'V',
//  a   m   l   C   D   ^ SftR  [*]  Alt  SPC  Cap  f.1  f.2  f.3  f.4  f.5 
   'B', 'N', 'M', '<', '>',0x3f,0x00,0x2a,0x00, ' ',0x00, 'v', 'w', 'x', 'y', 'z',
// f.6  f.7  f.8  f.9 f.10 Paus  ???  [7]  [8]  [9]  [-]  [4]  [5]  [6]  [+]  [1] 
  0x00,0x00,0x00,0x00,0x00,0x03,0x00, '7', '8', '9', '-', '4', '5', '6', '+', '1',
// [2]  [3]  [0]  [.]  ???  ???  ??? f.11 f.12
   '2', '3', '0', '.',0x00,0x00,0x00, '_', '|'
};

// GRPH (Alt)
byte CHR_TBL2[]={
// --   ESC   P   Q   R   S   T   U   V   W   X   O   |   O   BS  TAB 
  0x00,0x00,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,0xf8,0xf9,0xfa,0x8c,0x8b,0x00,0x00,
//  p   v   d   q   s   x   t   h   n   o      m  Ent Ctrl   `   r 
  0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,0xf0,0x8d,0x8a,0xfc,0x00,0x00,0x7f,0xe9,
//  c   e   f   g   i   j   k   G   F   S SftL   n   y   w   b   u 
  0xea,0xeb,0xec,0xed,0xee,0xef,0x8e,0x89,0xfd,0x00,0x00,0xe8,0x80,0x81,0x82,0x83,
//  a   m   l   C   D   ^ SftR  [*]  Alt  SPC  Cap  f.1  f.2  f.3  f.4  f.5 
  0x84,0x85,0x86,0x87,0x88,0xfe,0x00,0x9b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
// f.6  f.7  f.8  f.9 f.10 Paus  ???  [7]  [8]  [9]  [-]  [4]  [5]  [6]  [+]  [1] 
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x9a,0x93,0x97,0x9c,0x95,0x96,0x94,0x9d,0x99,
// [2]  [3]  [0]  [.]  ???  ???  ??? f.11 f.12
  0x92,0x98,0x8f,0x91,0x00,0x00,0x00,0x00,0xfb
};

// CTRL
byte CHR_TBL3[]={
// --   ESC   P   Q   R   S   T   U   V   W   X   O   |   O   BS  TAB 
  0x00,0x1b, '1', '2', '3', '4', '5', '6', '7', '8', '9', '0',0x00,0x1e,0x08,0x09,
//  p   v   d   q   s   x   t   h   n   o      m  Ent Ctrl   `   r 
  0x11,0x17,0x05,0x12,0x14,0x19,0x15,0x09,0x0f,0x10, '@',0x1b,0x0d,0x00,0x01,0x13,
//  c   e   f   g   i   j   k   G   F   S SftL   n   y   w   b   u 
  0x04,0x06,0x07,0x08,0x0a,0x0b,0x0c, ';', ':',0x00,0x1c,0x1d,0x1a,0x18,0x03,0x16,
//  a   m   l   C   D   ^ SftR  [*]  Alt  SPC  Cap  f.1  f.2  f.3  f.4  f.5 
  0x02,0x0e,0x0d,0x00,0x00,0x00,0x00,0x2a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
// f.6  f.7  f.8  f.9 f.10 Paus  ???  [7]  [8]  [9]  [-]  [4]  [5]  [6]  [+]  [1] 
  0xec,0xeb,0xe2,0xe1,0xe8,0x13,0x00, '7', '8', '9', '-', '4', '5', '6', '+', '1',
// [2]  [3]  [0]  [.]  ???  ???  ??? f.11 f.12
   '2', '3', '0', '.',0x00,0x00,0x00,0x00,0x1c
};

// 
byte CHR_TBL4[]={
// --   ESC   P   Q   R   S   T   U   V   W   X   O   |   O   BS  TAB 
  0x00,0x1b, '', '', '', '', '', '', '', '', '', '', '', '',0x08,0x09,
//  p   v   d   q   s   x   t   h   n   o      m  Ent Ctrl   `   r 
   '', '', '', '', '', '', '', '', '', '', '', '',0x0d,0x00, '', '',
//  c   e   f   g   i   j   k   G   F   S SftL   n   y   w   b   u 
   '', '', '', '', '', '', '', '', '',0x00,0x00, '', '', '', '', '',
//  a   m   l   C   D   ^ SftR  [*]  Alt  SPC  Cap  f.1  f.2  f.3  f.4  f.5 
   '', '', '', '', '', '',0x00,0x2a,0x00,0x20,0x00, 'q', 'r', 's', 't', 'u',
// f.6  f.7  f.8  f.9 f.10 Paus  ???  [7]  [8]  [9]  [-]  [4]  [5]  [6]  [+]  [1] 
  0xec,0xeb,0xe2,0xe1,0xe8,0x13,0x00, '7', '8', '9', '-', '4', '5', '6', '+', '1',
// [2]  [3]  [0]  [.]  ???  ???  ??? f.11 f.12
   '2', '3', '0', '.',0x00,0x00,0x00, '', ''
};

// +
byte CHR_TBL5[]={
// --   ESC   P   Q   R   S   T   U   V   W   X   O   |   O   BS  TAB 
  0x00,0x1b, '', '', '', '', '', '', '', '', '', '', '', '',0x12,0x09,
//  p   v   d   q   s   x   t   h   n   o      m  Ent Ctrl   `   r 
   '', '', '', '', '', '', '', '', '', '', '', '',0x0d,0x00, '', '',
//  c   e   f   g   i   j   k   G   F   S SftL   n   y   w   b   u 
   '', '', '', '', '', '', '', '', '',0x00,0x00, '', '', '', '', '',
//  a   m   l   C   D   ^ SftR  [*]  Alt  SPC  Cap  f.1  f.2  f.3  f.4  f.5 
   '', '', '', '', '', '',0x00,0x2a,0x00, ' ',0x00, 'v', 'w', 'x', 'y', 'z',
// f.6  f.7  f.8  f.9 f.10 Paus  ???  [7]  [8]  [9]  [-]  [4]  [5]  [6]  [+]  [1] 
  0x00,0x00,0x00,0x00,0x00,0x03,0x00, '7', '8', '9', '-', '4', '5', '6', '+', '1',
// [2]  [3]  [0]  [.]  ???  ???  ??? f.11 f.12
   '2', '3', '0', '.',0x00,0x00,0x00, '', ''
};

short key_int_chk_at(void){ return (short)KEY_INT; }
void  key_int_clr_at(void){ KEY_INT=0; }

void key_get_at(byte *sft,byte *chr)
{
	word kc,sf;

	(*sft)=0xff; (*chr)=0x00;
	if(!KEY_HIT) return;
	if(KEY_CHR>=0x40 && KEY_CHR<=0x44) return; // f.6-f.10

	kc=KEY_CHR; sf=sft_key();

	if(     kc==0x73) kc=0x57; // [_]:0x73 = [f.11]:0x57
	else if(kc==0x7d) kc=0x58; // [\]:0x7d = [f.12]:0x58

	if(     kc==0xcd) (*chr)=0x1c; // right
	else if(kc==0xcb) (*chr)=0x1d; // left
	else if(kc==0xc8) (*chr)=0x1e; // up
	else if(kc==0xd0) (*chr)=0x1f; // down
	else if(kc==0xd2) (*chr)=0x12; // INS
	else if(kc==0xd3) (*chr)=0x08; // DEL
	else if(kc==0xc7) (*chr)=(_SHFT_?0x0c:0x0b);  // HOME/CLR
	else if(kc==0xc9) (*chr)=0x0e; // PgUp
	else if(kc==0xd1) (*chr)=0x0f; // PgDn
	else if(kc==0xb5) (*chr)='/';  // [/]
	else if(kc<=0x58){
		if(sf&0x04){
			if(sf&0x01) (*chr)=CHR_TBL5[kc];
			else        (*chr)=CHR_TBL4[kc];
		} else {
			if(     sf&0x10) (*chr)=CHR_TBL3[kc];
			else if(sf&0x08) (*chr)=CHR_TBL2[kc];
			else {
				if(sf&0x01) (*chr)=CHR_TBL1[kc];
				else        (*chr)=CHR_TBL0[kc];
				if(sf&0x02){
					if(     (*chr)>='a' && (*chr)<='z') (*chr)^=0x20;
					else if((*chr)>='A' && (*chr)<='Z') (*chr)^=0x20;
				}
			}
		}
	}

	if(sf&0x10) (*sft)^=0x01;
	if(sf&0x01) (*sft)^=0x02;
	if(sf&0x04) (*sft)^=0x04;
	if(sf&0x02) (*sft)^=0x08;
	if(sf&0x08) (*sft)^=0x10;

	if((*chr)!=0){
		(*sft)^=0x40;
		if(     kc>=0x3b && kc<=0x3f) (*sft)^=0x80; // f.1 - f.5
		else if(kc>=0x47 && kc<=0x53) (*sft)^=0x80; // 10-Key
		else if(kc==0x37 || kc==0xb5) (*sft)^=0x80; // 10-Key[*][/]
	}
}

void game_key_at(byte *tbl)
{
	tbl[0]=tbl[1]=tbl[2]=0;
	if(HIT_TBL[0x10]) tbl[0]|=0x80; //  Q 
	if(HIT_TBL[0x11]) tbl[0]|=0x40; //  W 
	if(HIT_TBL[0x12]) tbl[0]|=0x20; //  E 
	if(HIT_TBL[0x1e]) tbl[0]|=0x10; //  A 
	if(HIT_TBL[0x20]) tbl[0]|=0x08; //  D 
	if(HIT_TBL[0x2c]) tbl[0]|=0x04; //  Z 
	if(HIT_TBL[0x2d]) tbl[0]|=0x02; //  X 
	if(HIT_TBL[0x2e]) tbl[0]|=0x01; //  C 

	if(HIT_TBL[0x47]) tbl[1]|=0x80; // [7]
	if(HIT_TBL[0x4b]) tbl[1]|=0x40; // [4]
	if(HIT_TBL[0x4f]) tbl[1]|=0x20; // [1]
	if(HIT_TBL[0x48]) tbl[1]|=0x10; // [8]
	if(HIT_TBL[0x50]) tbl[1]|=0x08; // [2]
	if(HIT_TBL[0x49]) tbl[1]|=0x04; // [9]
	if(HIT_TBL[0x4d]) tbl[1]|=0x02; // [6]
	if(HIT_TBL[0x51]) tbl[1]|=0x01; // [3]

	if(HIT_TBL[0x01]) tbl[2]|=0x80; // ESC
	if(HIT_TBL[0x02]) tbl[2]|=0x40; //  1 
	if(HIT_TBL[0x4a]) tbl[2]|=0x20; // [-]
	if(HIT_TBL[0x4e]) tbl[2]|=0x10; // [+]
	if(HIT_TBL[0x37]) tbl[2]|=0x08; // [*]
	if(HIT_TBL[0x0f]) tbl[2]|=0x04; // TAB
	if(HIT_TBL[0x39]) tbl[2]|=0x02; // SPC
	if(HIT_TBL[0x1c]) tbl[2]|=0x01; // RET
}

byte joy_key_at(void)
{
	byte joy;

	joy=0;
	if(HIT_TBL[0xc8]) joy|=0x01; // 
	if(HIT_TBL[0xd0]) joy|=0x02; // 
	if(HIT_TBL[0xcb]) joy|=0x04; // 
	if(HIT_TBL[0xcd]) joy|=0x08; // 
	if(HIT_TBL[0x2d]) joy|=0x20; // `
	if(HIT_TBL[0x2c]) joy|=0x40; // a

	return (joy^0xff);
}

void exkey_at(void)
{
	if(       HIT_TBL[0x40]){ // f.6
		if(_SHFT_) cmt_apss_rew(); else cmt_rew();
	} else if(HIT_TBL[0x41]){ // f.7
		if(_SHFT_) cmt_eject();
		else if(cmt_cntl_stat()!=0x01) cmt_play();
		else cmt_stop();
	} else if(HIT_TBL[0x42]){ // f.8
		if(_SHFT_) cmt_apss_ff(); else cmt_ff();
	} else if(HIT_TBL[0x43]){ // f.9
		cmt_disp_sw(2);
	} else if(HIT_TBL[0x44]){ // f.10
		if(_SHFT_) debug_sw(debug_chk()?0:1);
		else END_SW=1;
	}
}

/***********************************************************************
	
***********************************************************************/

short v_blank_at(void)
{
 	return (inp(0x3da)&0x08)?1:0;
}

void palet_at(int n,int g,int r,int b)
{
	r<<=2; if(r) r|=3;
	g<<=2; if(g) g|=3;
	b<<=2; if(b) b|=3;

	_disable();
	outp(0x3c8,n); outp(0x3c9,r);
	outp(0x3c9,g); outp(0x3c9,b);
	_enable();
}

void put_line_at(word x,word y,word l,struct GPTN *ptn)
{
	byte *vram;

	vram=(byte *)0xa0000l;
	vram+=(y*80)+x;

	outpw(0x03c4,0x0102); memcpy(vram,ptn->b,l);
	outpw(0x03c4,0x0202); memcpy(vram,ptn->r,l);
	outpw(0x03c4,0x0402); memcpy(vram,ptn->g,l);
	outpw(0x03c4,0x0802); memcpy(vram,ptn->m,l);
}

void put_font_at(short x,short y,struct GPTN *ptn)
{
	static byte *vram=(byte *)0xa0000l;
	word i,off;

	off=(x+(y*1280));
	for(i=0; i<16; i++){
		outpw(0x03c4,0x0102); vram[off]=ptn->b[i];
		outpw(0x03c4,0x0202); vram[off]=ptn->r[i];
		outpw(0x03c4,0x0402); vram[off]=ptn->g[i];
		outpw(0x03c4,0x0802); vram[off]=ptn->m[i];
		off+=80;
	}
}

void put88_at(short x,short y,struct GPTN *ptn)
{
	static byte *vram=(byte *)0xa0000l;
	word i,off;

	off=(x+(y*640));
	for(i=0; i<8; i++){
		outpw(0x03c4,0x0102); vram[off]=ptn->b[i];
		outpw(0x03c4,0x0202); vram[off]=ptn->r[i];
		outpw(0x03c4,0x0402); vram[off]=ptn->g[i];
		outpw(0x03c4,0x0802); vram[off]=ptn->m[i];
		off+=80;
	}
}

/**********************************************************************
	^I
**********************************************************************/

void vga_atr(byte num,byte pal)
{
	_disable();

	inp(0x3da);
	outp(0x3c0,num);
	outp(0x3c0,pal);

	inp(0x3da);
	outp(0x3c0,0x20); // reset

	_enable();
}

void vga_cls(void)
{
	byte *vrm;
	vrm=(byte *)0xa0000l;
	outpw(0x03c4,0x0102); memset(vrm,0,0x9600); // ڰ 1
	outpw(0x03c4,0x0202); memset(vrm,0,0x9600); // ڰ 2
	outpw(0x03c4,0x0402); memset(vrm,0,0x9600); // ڰ 3
	outpw(0x03c4,0x0802); memset(vrm,0,0x9600); // ڰ 4
}

//......................................................................

word init_at(void)
{
	union REGS r;
	byte i;

	// SCREEN_MODE 12H (640*480 16Color)
	r.w.ax=0x12; int386(0x10,&r,&r);
	for(i=0; i<16; i++) vga_atr(i,i);
	for(i=0; i<16; i++) palet_at(i,(i&4?15:0),(i&2?15:0),(i&1?15:0));
	outpw(0x03ce,0x0005); // ݃[hO
	outpw(0x03ce,0x0001); // SET/RESETgp
	outpw(0x03ce,0xff08); // ޯĥϽ=ffH
	outpw(0x03ce,0x0003); // ްײ
	vga_cls();

	kb_init_at();

	return 0;
}

void term_at(void)
{
	static byte pal[]={ 0,1,2,3,4,5,20,7,56,57,58,59,60,61,62,63 };
	union REGS r;
	byte i;

	for(i=0; i<16; i++) vga_atr(i,pal[i]);
	vga_cls();
	r.w.ax=0x03; int386(0x10,&r,&r);

	kb_reset_at();
}

