#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <dos.h>
#include <io.h>
#include "x1.h"
#include "x1_fdc.h"
#include "fdd_2d.h"
#include "fdd_d88.h"

// X1_DMA.C
extern byte DMA_ENBL;
extern byte DMA_REDY;
extern byte ENDB_FLG;

static struct FDC_REGS FDC={0};
static struct FDC_REGS FDC_TBL[4]={0};

//**********************************************************************

#define fdc_debug 0

#if fdc_debug

void _fdc_log(void)
{
	short x;
	x=0;
	x=str_dsp(x,0,7,"DRV:"); x=byt_dsp(x,0,7,FDC.drv)+2;
	x=str_dsp(x,0,7,"COM:"); x=byt_dsp(x,0,7,FDC.cmnd)+2;
	x=str_dsp(x,0,7,"DMA:"); x=byt_dsp(x,0,7,DMA_ENBL)+2;
	x=str_dsp(x,0,7,"OFF:"); x=int_dsp(x,0,7,FDC.sct_off)+2;
	str_dsp(0,1,7,"C   H   R   N   ");
	x=0;
	x=byt_dsp(x,1,7,FDC.c )+2; x=byt_dsp(x,1,7,FDC.h)+2;
	x=byt_dsp(x,1,7,FDC.r )+2; x=byt_dsp(x,1,7,FDC.n)+2;
}

void fdc_log(void)
{
	printf("DRIVE:%01d ",FDC.drv);
	printf("CMND:%02x ",FDC.cmnd);
	printf("C:%02x H:%02x R:%02x N:%02x ",FDC.c,FDC.h,FDC.r,FDC.n);
	printf("OFF:%04d ",FDC.sct_off);
	printf("\n");
}

#endif

/***********************************************************************
	ecc itbs[̏oɑ֐j
***********************************************************************/

short x1_eject_fd(short drv)
{
	if(drv<0 || drv>3) return 0;
	if(     FDC.img[drv]==1) return fdd_eject_2d( &FDC,drv);
	else if(FDC.img[drv]==2) return fdd_eject_d88(&FDC,drv);
	FDC.img[drv]=0;
	FDC.wpt[drv]=0;
	return 0;
}

short x1_set_fd(short drv,short type,byte *fname)
{
	if(drv<0 || drv>3) return 1;
	x1_eject_fd(drv);
	if(     type==1) return fdd_set_2d( &FDC,drv,fname);
	else if(type==2) return fdd_set_d88(&FDC,drv,fname,0l);
	return 1;
}

unsigned char *x1_get_fname(short drv)
{
	if(     FDC.img[drv]==1) return fdd_name_2d( drv);
	else if(FDC.img[drv]==2) return fdd_name_d88(drv);
	return NULL;
}

/***********************************************************************
	ecb ^I
***********************************************************************/

short init_fdc(void)
{
	FDC.drv=0;
	FDC.motor=0;
	FDC.cmnd=FDC.type=0;
	FDC.treg=FDC.data=0;
	FDC.step=1;
	FDC.bsy_wait=0;
	FDC.rdy_wait=0;
	FDC.sct_off=0;
	FDC.crc_off=0;
	FDC.c=0; FDC.h=0;
	FDC.r=1; FDC.n=0;
	memset(FDC.crc_dat,0,8);

	FDC.drv=3; FDC_TBL[3]=FDC;
	FDC.drv=2; FDC_TBL[2]=FDC;
	FDC.drv=1; FDC_TBL[1]=FDC;
	FDC.drv=0; FDC_TBL[0]=FDC;

	return 0;
}

/***********************************************************************
	ecb iwP猩h^nɑ֐j
***********************************************************************/

short inc_off(void)
{
	short ans;

	if(!FDC.motor) return 0;
	if(FDC.rdy_wait) return 0;
	if(FDC.bsy_wait){ FDC.bsy_wait--; return 0; }

	ans=0;
	if(     FDC.img[FDC.drv]==1) ans=inc_off_2d( &FDC);
	else if(FDC.img[FDC.drv]==2) ans=inc_off_d88(&FDC);

	if(ans) DMA_REDY=1; // <- DMA  ިݺ޳  ر

	return ans;
}

void x1_fdc_w(word P,byte V)
{
	short cmnd,n;

	P&=15;
	if(P==8){ // 
		FDC.bsy_wait=3;
		FDC.cmnd=V;
		cmnd=(V>>4);
		if(     cmnd>=0x0 && cmnd<=0x7) FDC.type=1;
		else if(cmnd>=0x8 && cmnd<=0xb) FDC.type=2;
		else if(cmnd==0xc             ) FDC.type=3;
		else if(cmnd>=0xe && cmnd<=0xf) FDC.type=3;
		else if(cmnd==0xd             ) FDC.type=4;
		else FDC.type=4;
		switch(cmnd){
			case 0: // ؽı
				FDC.motor=1; // ӰOn
				FDC.treg=FDC.c=0; FDC.step=1;
				if(V & 8) FDC.bsy_wait=0; // LAYDOCK !!!
			break;
			case 1: // 
				FDC.motor=1; // ӰOn
				FDC.step=(FDC.c<=FDC.data?1:-1);
				FDC.treg=FDC.data;
				FDC.c=FDC.data;
			break;
			case 2: case 3: // ï
				if(FDC.motor){ FDC.c+=FDC.step; if(cmnd & 1) FDC.treg=FDC.c; }
			break;
			case 4: case 5: // ïߥ
				if(FDC.motor){ FDC.step= 1; FDC.c++; if(cmnd & 1) FDC.treg=FDC.c; }
			break;
			case 6: case 7: // ïߥ
				if(FDC.motor){ FDC.step=-1; FDC.c--; if(cmnd & 1) FDC.treg=FDC.c; }
			break;

			case 0x8: case 0x9: // ذ ް
			case 0xa: case 0xb: // ײ  ް
				FDC.sct_off=0;
				if(FDC.motor && DMA_ENBL){
					FDC.bsy_wait=0; DMA_REDY=0; // <- DMA  ިݺ޳
				}
			break;

			case 0xc: // ذ ڽ
				if(     FDC.img[FDC.drv]==1) fdd_crc_2d( &FDC);
				else if(FDC.img[FDC.drv]==2) fdd_crc_d88(&FDC);
			break;
			case 0xe: break; // ذ ׯ
			case 0xf: break; // ײ  ׯ

			case 0xd: break; // ̫.
			default: break;
		}
	} else {
		FDC.bsy_wait=0;
		cmnd=(FDC.cmnd)>>4;
		switch(P){
			case 0x9: FDC.treg=V; FDC.r=1; break; // ׯ
			case 0xa: FDC.r=V; break; // 
			case 0xb: // ް
				FDC.data=V;
				if(cmnd==0x0a || cmnd==0x0b){
					if(     FDC.img[FDC.drv]==1) fdd_write_2d( &FDC,V);
					else if(FDC.img[FDC.drv]==2) fdd_write_d88(&FDC,V);
					inc_off();
				}
			break;
			case 0xc: // Ӱ/ײ/̪
				FDC_TBL[FDC.drv]=FDC;
				FDC=FDC_TBL[V&0x03];

				FDC.h=(V&0x10)?1:0;
				FDC.motor=(V&0x80)?1:0;

				if(!FDC.motor){
					FDC.rdy_wait=5; // !!!
					FDC.c=0; FDC.step=1;
				}
				FDC.cmnd=0; FDC.type=1; FDC.data=0;
				FDC.bsy_wait=2; // !!!
			break;
			default: break;
		}
	}

#if fdc_debug
	fdc_log();
#endif
}

#define WaitLngs 4

byte x1_fdc_r(word P)
{
	static word _off=0xffff;
	static byte _rec=0xff;
	static byte _cnt=0;
	static word _hole=0; // ޯΰ
	byte ans,cmnd;

	ans=0;
	P&=15;
	cmnd=(FDC.cmnd>>4);

	if(P!=8){ _rec=0xff; _off=0xffff; _cnt=0; }

	_hole++; if(_hole>=15) _hole=0;

	switch(P){
		case 0x8: // ð
			// ec
			if(!FDC.img[FDC.drv]){ ans=0x80; break; }

			// FDC.rdy_wait:ec̉]肷܂ł̃^CO
			// FDC.bsy_wait:R}hs̃^CO
			if(FDC.rdy_wait || FDC.bsy_wait){
				if(     FDC.rdy_wait){ FDC.rdy_wait--; ans=0x80; } // ɯĥި
				else if(FDC.bsy_wait){ FDC.bsy_wait--; ans=0x01; } // ޼ް
				if(FDC.type==1){
					ans|=0x20; // ͯޥ۰(1)
					if(!_hole) ans|=0x02; // ޯΰ
				}
				if(FDC.wpt[FDC.drv]){ // ײĥø
					if(    FDC.type==1) ans|=0x40;
					else if(cmnd==0x0a) ans|=0x40;
					else if(cmnd==0x0b) ans|=0x40;
					else if(cmnd==0x0f) ans|=0x40;
				}
				break;
			}

			if(FDC.type==2){ // ذ/ײ
				if(_rec==FDC.r && _off==FDC.sct_off){
					if(++_cnt<WaitLngs){ _cnt=0; inc_off(); }
				}
				_rec=FDC.r; _off=FDC.sct_off;
			}

			if(     FDC.img[FDC.drv]==1) ans|=fdd_stat_2d( &FDC);
			else if(FDC.img[FDC.drv]==2) ans|=fdd_stat_d88(&FDC);
			if(FDC.type==1 && !_hole) ans|=0x02; // ޯΰ
			if(DMA_ENBL && !(ans&2)) DMA_REDY=1; // <- DMA  ިݺ޳  ر
		break;
		case 0x9: ans=FDC.treg; break; // ׯ
		case 0xa: ans=FDC.r;    break; // 
		case 0xb: // ް
			ans=FDC.data;
			if(cmnd==0x08 || cmnd==0x09){ // ذޥް
				if(     FDC.img[FDC.drv]==1) FDC.data=fdd_read_2d( &FDC);
				else if(FDC.img[FDC.drv]==2) FDC.data=fdd_read_d88(&FDC);
				inc_off();
			} else if(cmnd==0x0c){ // ذޥڽ
				FDC.data=FDC.crc_dat[FDC.crc_off++];
				if(FDC.crc_off>5) FDC.crc_off=0;
			}
			ans=FDC.data;
		break;
		case 0xc: break; // FM
		case 0xd: break; // MFM
		case 0xe: break; // 1.6M
		case 0xf: break; // 500K/1M
	}

	return ans;
}

/***********************************************************************
	PZN^ǂݍ (CONFIG.CŎgp)
***********************************************************************/

short sctor_read(short drv,short trk,short sct,byte *buff)
{
	short ans;

	ans=0;
	if(     FDC.img[drv]==1) ans=fdd_sct_2d( drv,trk,sct,buff);
	else if(FDC.img[drv]==2) ans=fdd_sct_d88(drv,trk,sct,buff);

	return ans;
}

