#include <stdio.h>
#include <i86.h>
#include <dos.h>
#include "x1.h"
#include "x1_psg.h"

/**********************************************************************
	orf
**********************************************************************/

short psg_ini_98(void);
short psg_ini_at(void);
void psg_end_98(void);
void psg_end_at(void);

byte psg_sta_98(void);
byte psg_sta_at(void);
void psg_reg_98(byte V);
void psg_reg_at(byte V);
void psg_dat_98(byte V);
void psg_dat_at(byte V);

//---------------------------------------------------------------------

word PSG_ADR=0;
word PSG_STA=0;
byte PSG_VAL[16]={0};

//---------------------------------------------------------------------

byte _psg_r(byte reg)
{
	union REGS r;
	byte ans,dmy;

	if(       PSG_MODE==1){
		r.w.ax=0x11; // Func 11h : PSG ReadStatus
		r.h.ch=reg;
		int386(OPMDRV_IRQ,&r,&r);
	} else if(PSG_MODE==2){
		(SndPrm->psg_flg)=1;
		(SndPrm->psg_reg)=reg;
			r.w.dx=0; // dx : 0=PSG 1=OPM
			int386(SndPrm->int_num,&r,&r);
		ans=(SndPrm->psg_sta);
	} else if(SOUND_SW){
		if(PC98FLG) ans=psg_sta_98();
		else        ans=psg_sta_at();
	}

	return ans;
}

void _psg_w(byte reg,byte dat)
{
	union REGS r;
	short i;

	if(       PSG_MODE==1){
		r.w.ax=0x12; // Func 12h : PSG Send Message
		r.h.ch=reg; r.h.cl=dat;
		int386(OPMDRV_IRQ,&r,&r);
	} else if(PSG_MODE==2){
		(SndPrm->psg_flg)=0;
		(SndPrm->psg_reg)=reg;
		(SndPrm->psg_dat)=dat;
		r.w.dx=0; // dx : 0=PSG 1=OPM
		int386(SndPrm->int_num,&r,&r);
	} else if(SOUND_SW){
		if(PC98FLG){ psg_reg_98(reg); psg_dat_98(dat); }
		else{        psg_reg_at(reg); psg_dat_at(dat); }
	}
}

//*********************************************************************

short x1_psg_ini(void)
{
	// İݎg 0x0000-0x0fff
	PSG_VAL[0]=0xff; PSG_VAL[1]=0xff; // CH4
	PSG_VAL[2]=0xff; PSG_VAL[3]=0xff; // CH5
	PSG_VAL[4]=0xff; PSG_VAL[5]=0xff; // CH6

	// ѥɲގg 0x00-0x1f
	PSG_VAL[6]=0xff;

	// ۰
	// D7=1 D6=0
	// D5=CH6 D4=CH5 D3=CH4 ... ɲޥϽ 0=On / 1=Off
	// D2=CH6 D1=CH5 D0=CH4 ... İ Ͻ 0=On / 1=Off
	PSG_VAL[7]=0xbf;

	// ۰SW/ح
	// D4 ...... 0=Œ艹 1=۰
	// D3-D0 ... ح 0-15
	PSG_VAL[ 8]=0xbf; // CH4
	PSG_VAL[ 9]=0xbf; // CH5
	PSG_VAL[10]=0xbf; // CH6

	// ۰ߎ 0x0000-0xffff
	PSG_VAL[11]=0xff; PSG_VAL[12]=0xff;

	// ۰ߌ` 0-15
	PSG_VAL[13]=0;

	// I/O߰ (ޮè)
	PSG_VAL[14]=0;
	PSG_VAL[15]=0;

	if(!PSG_MODE){
		if(PC98FLG) psg_ini_98();
		else        psg_ini_at();
	}

	_psg_w( 7,0xbf); // JoyStickgp Sg[=OFF
	_psg_w(15,0x8f); // JoyStick-1gp
	_psg_w( 8,0); // =0
	_psg_w( 9,0); // =0
	_psg_w(10,0); // =0

	return 0;
}

void x1_psg_end(void)
{
	_psg_w( 7,0xbf); // JoyStickgp Sg[=OFF
	_psg_w(15,0x8f); // JoyStick-1gp
	_psg_w( 8,0); // =0
	_psg_w( 9,0); // =0
	_psg_w(10,0); // =0

	if(!PSG_MODE){
		if(PC98FLG) psg_end_98();
		else        psg_end_at();
	}
}

//---------------------------------------------------------------------

byte x1_psg_sta(void)
{
	if(       PSG_ADR==14){ // ޮè 1
		PSG_STA=0x90|pad_get();
	} else if(PSG_ADR==15){ // ޮè 2
		PSG_STA=0xff;
	} else {
		PSG_STA=_psg_r(PSG_ADR);
	}
	return PSG_STA;
}

void x1_psg_reg(byte V)
{
	PSG_ADR=(word)(V&15);
}

void x1_psg_dat(byte V)
{
	PSG_VAL[PSG_ADR]=V;
	_psg_w(PSG_ADR,V);

	psg_trace_reg(PSG_ADR,V);
}

//---------------------------------------------------------------------

void x1_psg_pause(void)
{
	_psg_w(7,0xbf);
}

void x1_psg_continue(void)
{
	short i;
	for(i=0; i<=13; i++) _psg_w(i,PSG_VAL[i]);
}

