/*  -----------------------------------------------------------

			Z80 ֘A
			ςȂ֐(ďd)

	----------------------------------------------------------- */

#include "z80.h"
#include "z80codes.h"

extern	Z80_Regs 	R;

extern	byte		ZSTable[];
extern	byte		ZSPTable[];
extern	byte		Z80_ICount;
extern	word		M_RDMEM_OPCODE_WORD(void);


void M_POP(word *Rg) {						//  ȂςĂ邶()
	*Rg = Z80_RDMEM(R.SP.D) + ((word)Z80_RDMEM(R.SP.D + 1) << 8);
    R.SP.W.l+=2;
}

void M_PUSH(word Rg) {
    R.SP.W.l-=2;
    Z80_WRMEM(R.SP.D, (byte)(Rg & 0x00ff));
	Z80_WRMEM(R.SP.D+1, (byte)(Rg>>8));
}

void M_CALL(void) {
	 word	q;

	q = M_RDMEM_OPCODE_WORD();
	M_PUSH(R.PC.D);
	R.PC.D = q;
	Z80_ICount += 7;
}

void M_JP(void) {

	R.PC.D = M_RDOP_ARG(R.PC.D)+(M_RDOP_ARG((word)(R.PC.D+1)) << 8);
}

void M_JR(void) {

	R.PC.W.l += cbw(M_RDOP_ARG(R.PC.D)) + 1;
	Z80_ICount += 5;
}

void M_RET(void) {

   M_POP(&R.PC.D);
   Z80_ICount += 6;
}

void M_RST(word Addr) {

    M_PUSH(R.PC.D);
    R.PC.D = Addr;
}

void M_BIT(int Bit, byte Reg) {

    R.AF.B.l = (byte)((R.AF.B.l & C_FLAG) |
					((Reg&(1<<Bit))? ((Bit==7)?S_FLAG:0):Z_FLAG)) |
					(byte)H_FLAG;
}


void M_AND(byte Reg) {
      R.AF.B.h &= Reg;
      R.AF.B.l = ZSPTable[R.AF.B.h] | (byte)H_FLAG;
}

void M_OR(byte Reg) {
      R.AF.B.h |= Reg;
      R.AF.B.l = ZSPTable[R.AF.B.h];
}

void M_XOR(byte Reg) {

	R.AF.B.h ^= Reg;
	R.AF.B.l = ZSPTable[R.AF.B.h];

}

void M_RLCA(void) {

	R.AF.B.h = (byte)((R.AF.B.h << 1) | ((R.AF.B.h & 0x80) >> 7));
	R.AF.B.l = (R.AF.B.l & (byte)0xEC) | (R.AF.B.h & (byte)C_FLAG);
}

void M_RRCA(void) {
	R.AF.B.l = (R.AF.B.l & (byte)0xEC) | (R.AF.B.h & (byte)C_FLAG);
	R.AF.B.h = (byte)((R.AF.B.h >> 1) | (R.AF.B.h << 7));
}

void M_RLA(void) {

	byte	i;

	i = R.AF.B.l & (byte)C_FLAG;
	R.AF.B.l = (byte)((R.AF.B.l & 0xEC) | ((R.AF.B.h & 0x80) >> 7));
	R.AF.B.h = (byte)(R.AF.B.h << 1) | i;
}

void M_RRA(void) {

	word	i;

	i = R.AF.B.l & C_FLAG;
	R.AF.B.l = (byte)((R.AF.B.l & 0xEC) | (R.AF.B.h & 0x01));
	R.AF.B.h = (byte)((R.AF.B.h >> 1) | (i << 7));
}

void M_ADD(byte Reg) {

	word	q;

	q = (word)R.AF.B.h + (word)Reg;
	R.AF.B.l = (byte)(ZSTable[q & 255] | ((q&256)>>8) |
					((R.AF.B.h^q^Reg) & H_FLAG) |
					(((Reg^R.AF.B.h^0x80) & (Reg^q)&0x80)>>5));
	R.AF.B.h = (byte)q;
}

void M_ADC(byte Reg) {

	word	q;
	q = (word)R.AF.B.h + (word)Reg + (word)(R.AF.B.l&1);
	R.AF.B.l = (byte)(ZSTable[q & 255]|((q & 256) >> 8)|
					((R.AF.B.h^q^Reg) & H_FLAG) |
					(((Reg^R.AF.B.h^0x80) & (Reg^q)&0x80)>>5));
	R.AF.B.h = (byte)q;
}

void M_SUB(byte Reg) {

	word	q;
	q = (word)R.AF.B.h - (word)Reg;
	R.AF.B.l = (byte)(ZSTable[q & 255] | ((q & 256) >> 8) | N_FLAG |
					((R.AF.B.h^q^Reg) & H_FLAG) |
					(((Reg^R.AF.B.h) & (R.AF.B.h^q)&0x80)>>5));
	R.AF.B.h = (byte)q;
}

void M_SBC(byte Reg) {

	word	q;

	q = (word)R.AF.B.h - (word)Reg - (word)(R.AF.B.l&1);
	R.AF.B.l = (byte)(ZSTable[q & 255] | ((q & 256)>>8) | N_FLAG |
					((R.AF.B.h^q^Reg) & H_FLAG)|
					(((Reg^R.AF.B.h) & (R.AF.B.h^q)&0x80)>>5));
	R.AF.B.h = (byte)q;
}

void M_CP(byte Reg) {

	word	q;

	q = (word)R.AF.B.h - (word)Reg;
	R.AF.B.l = (byte)(ZSTable[q & 255] | ((q & 256)>>8) | N_FLAG |
					((R.AF.B.h^q^Reg) & H_FLAG) |
					(((Reg^R.AF.B.h) & (R.AF.B.h^q)&0x80)>>5));
}
