/*  -----------------------------------------------------------

			Z80 ֘A
			CBxx, DDCBxxxx, FDCBxxxx̏

	----------------------------------------------------------- */

#include	"z80.h"

extern	Z80_Regs _near	R;

extern	byte		ZSPTable[];

word cbw(byte code) {

	if (code & 0x80) {
		return(0xff00 | code);
	}
	return((word)code);
}

void z80reg_set(byte mode, byte b) {

	switch(mode & 7) {
		case 0:
			R.BC.B.h = b;						//	b
			break;
		case 1:
			R.BC.B.l = b;						//	c
			break;
		case 2:
			R.DE.B.h = b;						//	d
			break;
		case 3:
			R.DE.B.l = b;						//	e
			break;
		case 4:
			R.HL.B.h = b;						//	h
			break;
		case 5:
			R.HL.B.l = b;						//	l
			break;
		case 6:
			Z80_WRMEM(R.HL.W.l, b);				// (hl)
			return;
		default:
			R.AF.B.h = b;						//	a
			break;
	}
}


byte z80reg_get(byte mode) {

	switch(mode & 7) {
		case 0:
			return(R.BC.B.h);					//	b
		case 1:
			return(R.BC.B.l);					//	c
		case 2:
			return(R.DE.B.h);					//	d
		case 3:
			return(R.DE.B.l);					//	e
		case 4:
			return(R.HL.B.h);					//	h
		case 5:
			return(R.HL.B.l);					//	l
		case 6:
			return(Z80_RDMEM(R.HL.W.l));		//	(hl)
		default:
			return(R.AF.B.h);					//	a
	}
}




static	byte	bitbit[] = {0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80};
static	byte	reg;



void cbreg_proc(byte code) {

	byte	bitd;
	word	q;

	bitd = bitbit[(code >> 3) & 7];
	switch((short)code & 0x00c0) {
		case 0x0040:						// bit
	        R.AF.B.l = (R.AF.B.l & (byte)C_FLAG) | (byte)H_FLAG;
			if (reg & bitd) {
				if (bitd == 0x80) {
					R.AF.W.l |= S_FLAG;
				}
			}
			else {
				R.AF.W.l |= Z_FLAG;
			}
			return;
		case 0x0080:						// res
			reg &= (byte)(~bitd);
			return;
		case 0x00c0:						// set
			reg |= bitd;
			return;
	}
	switch((short)code & 0x0038) {
		case 0x0000:						// rlc
			q = reg >> 7;
			reg = (byte)((reg << 1) | q);
			break;
		case 0x0008:						// rrc
			q = reg & 1;
			reg = (byte)((reg >> 1) | (q << 7));
			break;
		case 0x0010:						// rl
			q = reg >> 7;
			reg = (byte)((reg << 1) | (R.AF.B.l & 1));
			break;
		case 0x0018:						// rr
			q = reg & 1;
			reg = (byte)((reg >> 1) | (R.AF.B.l << 7));
			break;
		case 0x0020:						// sla
			q = reg >> 7;
			reg <<= 1;
			break;
		case 0x0028:						// sra
			q = reg & 1;
			reg = (byte)((reg >> 1) | (reg & 0x80));
			break;
		case 0x0030:						// sll
			q = reg >> 7;
			reg = (byte)((reg << 1) | 1);
			break;
		default:							// srl
			q = (byte)(reg & 1);
			reg >>= 1;
	}
	R.AF.B.l = (byte)(ZSPTable[reg] | q);
}

void proc_cb(byte code) {

	reg = z80reg_get(code);
	cbreg_proc(code);
	z80reg_set(code, reg);
}


void proc_dd_cb(byte code1, byte code2) {

	word	memad;

	memad = R.IX.W.l + cbw(code1);
	reg = Z80_RDMEM(memad);
	if ((code2 & 7) != 6) {						// ꉞΉ(?)
		cbreg_proc(code2);
		z80reg_set(code2, reg);
		Z80_WRMEM(memad, reg);
		return;
	}
	cbreg_proc(code2);
	Z80_WRMEM(memad, reg);
}


void proc_fd_cb(byte code1, byte code2) {

	word	memad;

	memad = R.IY.W.l + cbw(code1);
	reg = Z80_RDMEM(memad);
	if ((code2 & 7) != 6) {						// ꉞΉ(?)
		cbreg_proc(code2);
		z80reg_set(code2, reg);
		Z80_WRMEM(memad, reg);
		return;
	}
	cbreg_proc(code2);
	Z80_WRMEM(memad, reg);
}
